package com.trendify.controller;


import com.trendify.entity.Cart;
import com.trendify.entity.CartItem;
import com.trendify.service.CartService;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/cart")
public class CartController {

    @Autowired
    private CartService cartService;

    @GetMapping("/getAllCartItems")
    public Flux<Cart> getAll(){
        return cartService.getAll();
    }

    @GetMapping("/getCart/{userId}")
    public Mono<Cart> getCart(@PathVariable String userId) {
        return cartService.getCart(userId);
    }

    @PostMapping("/addItem/{userId}/items")
    public Mono<Cart> addItemToCart(@PathVariable String userId, @RequestBody CartItem item) {
        return cartService.addItemToCart(userId, item);
    }

    @DeleteMapping("/removeItem/{userId}/items/{productId}")
    public Mono<Cart> removeItemFromCart(@PathVariable String userId, @PathVariable String productId) {
        return cartService.removeItemFromCart(userId, productId);
    }
}